Index: trunk/VUT/doc/SciReport/preprocessing.tex
===================================================================
--- trunk/VUT/doc/SciReport/preprocessing.tex	(revision 243)
+++ trunk/VUT/doc/SciReport/preprocessing.tex	(revision 246)
@@ -1,2 +1,95 @@
 \chapter{Visibility Preprocessing}
+
+
 \section{Introduction}
+
+
+\section{Related Work}
+
+
+\section{Overview of Visibility Preprocessor}
+
+The proposed visibility preprocessing framework consists of two major
+steps.
+\begin{itemize}
+\item The first step is an aggresive visibility sampling which gives
+initial estimate about global visibility in the scene. The sampling
+itself involves several strategies which will be described in
+section~\ref{sec:sampling}. The imporant property of the aggresive
+sampling step is that it provides a fast progressive solution to
+global visibility and thus it can be easily integrated into the
+game development cycle.
+
+\item The second step is visibility verification. This step turns the
+previous aggresive visibility solution into either exact, conservative
+or error bound aggresive solution. The choice of the particular
+verifier is left on the user in order to select the best for a
+particular scene, application context and time constrains. For
+example, in scenes like a forest an error bound aggresive visibility
+can be the best compromise between the resulting size of the PVS (and
+framerate) and the visual quality. The exact or conservative algorithm
+can however be chosen for urban scenes where of even small objects can
+be more distructing for the user.
+
+
+\section{Aggresive Global Visibility Sampling}
+
+In traditional visibility preprocessing the view space is
+subdivided into viewcells and for each view cell the set of visible
+objects --- potentially visible set (PVS) is computed. This framewoirk
+has bee used for conservative, aggresive and exact algorithms.
+
+We propose a different strategy which has several advantages for
+sampling based aggresive visibility preprocessing. The stategy is
+based on the following fundamental ideas:
+\begin{itemize}
+\item Replace the roles of view cells and objects
+\item Compute progressive global visibility instead of sequential from-region visibility
+\end{itemize}
+
+Both of these points are addressed bellow in more detail.
+
+\subsection{From-object based visibility}
+
+Our framework is based on the idea of 
+
+A visibility sample is computed by casting a ray from an object
+towards the viewcells and computing the nearest intersection with the
+scene objects. All view cells pierced by the ray segment can the
+object and thus the object can be added to their PVS. If the ray is
+terminated at another scene object the PVS of the pierced view cells
+can also be extended by this terminating object. Thus a single ray
+sample piercing $n$ viewcells which is bound by two distinct objects
+contributes by at most $2*n$ entries to the current PVSs.
+
+At this phase of the computation we not only start the samples from
+the objects, but we also store the PVS information centered at the
+objects. Instead of storing a PVSs consting of objects visible from
+view cells, every object maintains a PVS consisting of potentially
+visible view cells. While these representations contain exactly the
+same information as we shall see later the object centered PVS is
+better suited for the importance sampling phase as well as the
+visibility verification phase.
+
+
+\subsection{Progressive Randomized Sampling}
+
+
+
+
+\subsection{Importance Sampling}
+
+
+\section{Visibility Verification}
+
+
+\subsection{Exact Verifier}
+
+
+\subsection{Conservative Verifier}
+
+
+\subsection{Error Bound Verifier}
+
+
+
Index: trunk/VUT/doc/SciReport/default.mac
===================================================================
--- trunk/VUT/doc/SciReport/default.mac	(revision 246)
+++ trunk/VUT/doc/SciReport/default.mac	(revision 246)
@@ -0,0 +1,7 @@
+% Macros for c2tex translator
+\def\mymd{\mdseries}
+\def\keya{\rm\bf}
+\def\keyb{\sl\mymd}
+\def\comment{\sl\mymd}
+\def\symbol{\rm\mymd}
+\def\normal{\rm\mymd}