Index: /trunk/VUT/doc/SciReport/preprocessing.tex
===================================================================
--- /trunk/VUT/doc/SciReport/preprocessing.tex	(revision 246)
+++ /trunk/VUT/doc/SciReport/preprocessing.tex	(revision 247)
@@ -31,4 +31,5 @@
 can however be chosen for urban scenes where of even small objects can
 be more distructing for the user.
+\end{itemize}
 
 
@@ -52,14 +53,20 @@
 \subsection{From-object based visibility}
 
-Our framework is based on the idea of 
-
-A visibility sample is computed by casting a ray from an object
-towards the viewcells and computing the nearest intersection with the
-scene objects. All view cells pierced by the ray segment can the
-object and thus the object can be added to their PVS. If the ray is
-terminated at another scene object the PVS of the pierced view cells
-can also be extended by this terminating object. Thus a single ray
+Our framework is based on the idea of sampling visibility by casting
+casting rays through the scene and collecting their contributions. A
+visibility sample is computed by casting a ray from an object towards
+the viewcells and computing the nearest intersection with the scene
+objects. All view cells pierced by the ray segment can the object and
+thus the object can be added to their PVS. If the ray is terminated at
+another scene object the PVS of the pierced view cells can also be
+extended by this terminating object. Thus a single ray can make a
+number of contributions to the progressively computed PVSs. A ray
 sample piercing $n$ viewcells which is bound by two distinct objects
-contributes by at most $2*n$ entries to the current PVSs.
+contributes by at most $2*n$ entries to the current PVSs. Appart from
+this performance benefit there is also a benefit in terms of the
+sampling density: Assuming that the view cells are usually much larger
+than the objects (which is typically the case) starting the sampling
+deterministically from the objects increases the probability of small
+objects being captured in the PVS.
 
 At this phase of the computation we not only start the samples from
@@ -73,10 +80,43 @@
 
 
-\subsection{Progressive Randomized Sampling}
+\subsection{Basic Randomized Sampling}
 
 
+The first phase of the sampling works as follows: At every pass of the
+algorithm visits scene objects sequentially. For every scene object we
+randomly choose a point on its surface. Then a ray is cast from the
+selected point according to the randomly chosen direction. We use a
+uniform distribution of the ray directions with respect to the
+halfspace given by the surface normal. Using this strategy the samples
+at deterministicaly placed at every object, with a randomization of
+the location on the object surface. The uniformly distributed
+direction is a simple and fast strategy to gain initial visibility
+information.
 
 
-\subsection{Importance Sampling}
+The described algorithm accounts for the irregular distribution of the
+objects: more samples are placed at locations containing more
+objects. Additionally every object is sampled many times depending on
+the number of passes in which this sampling strategy is applied. This
+increases the chance of even a small object being captured in the PVS
+of the view cells from which it is visible.
+
+
+\subsection{Accounting for View Cell Distribution}
+
+The first modification to the basic algorithm accounts for
+irregular distribution of the viewcells. Such a case in common for
+example in urban scenes where the viewcells are mostly distributed in
+a horizontal direction and more viewcells are placed at denser parts
+of the city. The modification involves replacing the uniformly
+distributed ray direction by direction distribution according to the
+local view cell density. We select a random viecell which lies at the
+halfpace given by the surface normal at the chosen point. We pick a
+random point inside the view cell and cast a ray towards this point.
+
+
+\subsection{Accounting for Visibility Events}
+
+
 
 
@@ -85,4 +125,11 @@
 
 \subsection{Exact Verifier}
+
+The exact verifier computes exact mutual visibility between two
+polyhedrons in the scene. This is computed by testing visibility
+between all pairs of potentially polygons of these polyhedrons.
+
+
+
 
 